// Prototype de la fonction
BOOL association(char*, const char*);

// Le fonction proprement dite:
//		FALSE= pas de lanceur pour le type
//		TRUE = un lanceur pour le type
// Elle stocke le nom du lanceur dans dest
BOOL association(char *dest, const char *type)
{
	BOOL comment=FALSE, egal=FALSE;
	char buff[200], ext[5];
	FILE *f;
	short c, i=0, n=0;
#ifdef debug
char tab[100];
#endif

debug_ST_helpMsg("association");
	// Si type ou dest est NULL on quitte
	if (!type || !strlen(type) || !dest) return FALSE;

	// On ouvre le fichier contenant les associations
	if (!(f=fopen("main\\kbdfuncc", "rt"))) return FALSE;
debug_ST_helpMsg("kbdfuncc ouvert");
debug_ST_helpMsg(type);

	// On construit les associations
	while ((c=fgetc(f))!=EOF)
	{
		switch (c)
		{
			// Caractre indiquant le dbut d'un commentaire
			case '#':
				comment=TRUE;
				break;

			// Fin d'une ligne
			case 13:
				// Il doit y avoir un '=' sur la ligne pour qu'elle soit valide
				if (!strchr(buff, '=')) comment=TRUE;

				// Le ligne n'est pas un commentaire
				if (!comment)
				{
debug_ST_helpMsg(buff);
					n=0;
					while (buff[n] && buff[n]!='=')
					{
						ext[n]=buff[n];
						n++;
						ext[n]=0;
					}
#ifdef debug
sprintf(tab, "type=%s", type);
debug_ST_helpMsg(tab);
sprintf(tab, "ext=%s", ext);
debug_ST_helpMsg(tab);
#endif

					// On compare l'association
					if (!strcmp(ext, type))
					{
debug_ST_helpMsg("L'association existe");
debug_ST_helpMsg(buff+n+1);
						strcpy(dest, buff+n+1);
						fclose(f);

					// On verifie l'existence du lanceur
					if (!(f=fopen(dest, "rb")))
					{
						sprintf(buff, "%s intouvable", dest);
						ST_helpMsg(buff);
					}
					else fclose(f);

						return TRUE;
					}
				}

				// On rinitialise les variables pour tudier une nouvelle ligne
				comment=FALSE;
				i=0;
				buff[0]=0;
				ext[0]=0;
				break;

			default:
				if (!comment)
				{
					if (!isextalnum(c) && c!='\\' && c!='=' && c!=' ')
					{
						comment=TRUE;
					}
					else
					{
						// Une ligne valide fait au maximum 22 charactres
						// Le signe gal apparat au maximum  la 5me position
						// L'espace n'est valide que dans l'extension (avant le '=')
						if (i>22 && (c=='=' && i>=5) && (c==' ' && egal==TRUE))
						{
							comment=TRUE;
							break;
						}

						if (c=='=') egal=TRUE;
						buff[i]=c;
						i++;
						buff[i]=0;
					}
				}
		}
	}

	// Si on a quitter la boucle, mais que comment est FALSE alors la dernire ligne est valide
	if (strchr(buff, '=') && !comment)
	{
debug_ST_helpMsg(buff);
		n=0;
		while (buff[n] && buff[n]!='=')
		{
			ext[n]=buff[n];
			n++;
			ext[n]=0;
		}
#ifdef debug
sprintf(tab, "type=%s", type);
debug_ST_helpMsg(tab);
sprintf(tab, "ext=%s", ext);
debug_ST_helpMsg(tab);
#endif

		// On compare l'association
		if (!strcmp(ext, type))
		{
debug_ST_helpMsg("L'association existe");
debug_ST_helpMsg(buff+n+1);
			strcpy(dest, buff+n+1);
			fclose(f);

			// On verifie l'existence du lanceur
			if (!(f=fopen(dest, "rb")))
			{
				sprintf(buff, "%s intouvable", dest);
				ST_helpMsg(buff);
			}
			else fclose(f);

			return TRUE;
		}
	}

	// Si on arrive ici c'est que le programme n'a pas t lanc
	fclose(f);
	return FALSE;
}
